#!/usr/bin/python3


import json, os
from qemu import QEMUMonitorProtocol
from threading import Thread


# Start a VM before the script launch: qemu-system-x86_64 -qmp unix:/tmp/qmp,server,nowait

qmp_socket = '/tmp/qmp'
qmp = QEMUMonitorProtocol(qmp_socket)

qmp.connect()

qmp.cmd('qmp_capabilities')

def start_stop():
    while True:
        qmp.cmd('nbd-server-start', {'addr':{'type':'unix','data':{'path':'/tmp/nbd-sock'}}})
        qmp.cmd('nbd-server-stop')

def nbd_list():
    while True:
        os.system('qemu-nbd -L -k /tmp/nbd-sock')

sst = Thread(target=start_stop)
sst.start()
nlt = Thread(target=nbd_list)
nlt.start()

sst.join()
nlt.join()
